<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>CS 250 Data Structures: DataStructure::BinarySearchTree&lt; TK, TD &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">CS 250 Data Structures
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespaceDataStructure.html">DataStructure</a></li><li class="navelem"><a class="el" href="classDataStructure_1_1BinarySearchTree.html">BinarySearchTree</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pri-methods">Private Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="#friends">Friends</a> &#124;
<a href="classDataStructure_1_1BinarySearchTree-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">DataStructure::BinarySearchTree&lt; TK, TD &gt; Class Template Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>A template binary search tree class that takes a KEY and a DATA.  
 <a href="classDataStructure_1_1BinarySearchTree.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="BinarySearchTree_8h_source.html">BinarySearchTree.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ab5814e0a82125eafc6f40fd84f793eb4"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1BinarySearchTree.html#ab5814e0a82125eafc6f40fd84f793eb4">BinarySearchTree</a> ()</td></tr>
<tr class="memdesc:ab5814e0a82125eafc6f40fd84f793eb4"><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="classDataStructure_1_1BinarySearchTree.html" title="A template binary search tree class that takes a KEY and a DATA.">BinarySearchTree</a> Constructor.  <a href="classDataStructure_1_1BinarySearchTree.html#ab5814e0a82125eafc6f40fd84f793eb4">More...</a><br /></td></tr>
<tr class="separator:ab5814e0a82125eafc6f40fd84f793eb4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2470cabc162d697002447db1cb85dc8b"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1BinarySearchTree.html#a2470cabc162d697002447db1cb85dc8b">~BinarySearchTree</a> ()</td></tr>
<tr class="memdesc:a2470cabc162d697002447db1cb85dc8b"><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="classDataStructure_1_1BinarySearchTree.html" title="A template binary search tree class that takes a KEY and a DATA.">BinarySearchTree</a> Destructor.  <a href="classDataStructure_1_1BinarySearchTree.html#a2470cabc162d697002447db1cb85dc8b">More...</a><br /></td></tr>
<tr class="separator:a2470cabc162d697002447db1cb85dc8b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1539ce01efd9c9a6c1b83c2b0ca6b6f3"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1BinarySearchTree.html#a1539ce01efd9c9a6c1b83c2b0ca6b6f3">Push</a> (const TK &amp;newKey, const TD &amp;newData)</td></tr>
<tr class="memdesc:a1539ce01efd9c9a6c1b83c2b0ca6b6f3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function that begins the recursive push function. Add new item to tree.  <a href="classDataStructure_1_1BinarySearchTree.html#a1539ce01efd9c9a6c1b83c2b0ca6b6f3">More...</a><br /></td></tr>
<tr class="separator:a1539ce01efd9c9a6c1b83c2b0ca6b6f3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adab16db3a643345ac73548d01f5a5fdf"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1BinarySearchTree.html#adab16db3a643345ac73548d01f5a5fdf">Contains</a> (const TK &amp;key)</td></tr>
<tr class="memdesc:adab16db3a643345ac73548d01f5a5fdf"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function that begins the recursive contains function. Check if key is contained within the tree.  <a href="classDataStructure_1_1BinarySearchTree.html#adab16db3a643345ac73548d01f5a5fdf">More...</a><br /></td></tr>
<tr class="separator:adab16db3a643345ac73548d01f5a5fdf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a616fe60e0b95d4a4910c9daf22f8f091"><td class="memItemLeft" align="right" valign="top">TD &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1BinarySearchTree.html#a616fe60e0b95d4a4910c9daf22f8f091">GetData</a> (const TK &amp;key)</td></tr>
<tr class="memdesc:a616fe60e0b95d4a4910c9daf22f8f091"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function that begins the recursive find node function. Get data relayed to some key stored in the tree.  <a href="classDataStructure_1_1BinarySearchTree.html#a616fe60e0b95d4a4910c9daf22f8f091">More...</a><br /></td></tr>
<tr class="separator:a616fe60e0b95d4a4910c9daf22f8f091"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa76af5cc4dffce8274d99c53b01259ca"><td class="memItemLeft" align="right" valign="top">TD &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1BinarySearchTree.html#aa76af5cc4dffce8274d99c53b01259ca">GetRoot</a> ()</td></tr>
<tr class="memdesc:aa76af5cc4dffce8274d99c53b01259ca"><td class="mdescLeft">&#160;</td><td class="mdescRight">Retrieves the item at the root.  <a href="classDataStructure_1_1BinarySearchTree.html#aa76af5cc4dffce8274d99c53b01259ca">More...</a><br /></td></tr>
<tr class="separator:aa76af5cc4dffce8274d99c53b01259ca"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afa25866546d8f5b0abeebf3fabe5f0ba"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1BinarySearchTree.html#afa25866546d8f5b0abeebf3fabe5f0ba">PopRoot</a> ()</td></tr>
<tr class="memdesc:afa25866546d8f5b0abeebf3fabe5f0ba"><td class="mdescLeft">&#160;</td><td class="mdescRight">Removes the root item and reorganizes the tree.  <a href="classDataStructure_1_1BinarySearchTree.html#afa25866546d8f5b0abeebf3fabe5f0ba">More...</a><br /></td></tr>
<tr class="separator:afa25866546d8f5b0abeebf3fabe5f0ba"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a459c979a497014e725f20e0584eefe97"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1BinarySearchTree.html#a459c979a497014e725f20e0584eefe97">ShiftNodes</a> (<a class="el" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode</a>&lt; TK, TD &gt; *node1, <a class="el" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode</a>&lt; TK, TD &gt; *node2)</td></tr>
<tr class="memdesc:a459c979a497014e725f20e0584eefe97"><td class="mdescLeft">&#160;</td><td class="mdescRight">Shifts nodes for deletion operation.  <a href="classDataStructure_1_1BinarySearchTree.html#a459c979a497014e725f20e0584eefe97">More...</a><br /></td></tr>
<tr class="separator:a459c979a497014e725f20e0584eefe97"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a413cb728337d1aacb29fac517dc78962"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1BinarySearchTree.html#a413cb728337d1aacb29fac517dc78962">GetInOrder</a> ()</td></tr>
<tr class="memdesc:a413cb728337d1aacb29fac517dc78962"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function that begins the recursive in-order traversal.  <a href="classDataStructure_1_1BinarySearchTree.html#a413cb728337d1aacb29fac517dc78962">More...</a><br /></td></tr>
<tr class="separator:a413cb728337d1aacb29fac517dc78962"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6331270db8ac855cb6d71bf64c3a2376"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1BinarySearchTree.html#a6331270db8ac855cb6d71bf64c3a2376">GetPreOrder</a> ()</td></tr>
<tr class="memdesc:a6331270db8ac855cb6d71bf64c3a2376"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function that begins the recursive pre-order traversal.  <a href="classDataStructure_1_1BinarySearchTree.html#a6331270db8ac855cb6d71bf64c3a2376">More...</a><br /></td></tr>
<tr class="separator:a6331270db8ac855cb6d71bf64c3a2376"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aad0331b880a93a1f5da7eafa54422c23"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1BinarySearchTree.html#aad0331b880a93a1f5da7eafa54422c23">GetPostOrder</a> ()</td></tr>
<tr class="memdesc:aad0331b880a93a1f5da7eafa54422c23"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function that begins the recursive post-order traversal.  <a href="classDataStructure_1_1BinarySearchTree.html#aad0331b880a93a1f5da7eafa54422c23">More...</a><br /></td></tr>
<tr class="separator:aad0331b880a93a1f5da7eafa54422c23"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afaa0ece8c510e5c850b85a6b72f1940d"><td class="memItemLeft" align="right" valign="top">TK &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1BinarySearchTree.html#afaa0ece8c510e5c850b85a6b72f1940d">GetMinKey</a> ()</td></tr>
<tr class="memdesc:afaa0ece8c510e5c850b85a6b72f1940d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function that begins the recursive get min key, returns key with smallest value.  <a href="classDataStructure_1_1BinarySearchTree.html#afaa0ece8c510e5c850b85a6b72f1940d">More...</a><br /></td></tr>
<tr class="separator:afaa0ece8c510e5c850b85a6b72f1940d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a16f629f10c23872f240c145d915a267d"><td class="memItemLeft" align="right" valign="top">TK &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1BinarySearchTree.html#a16f629f10c23872f240c145d915a267d">GetMaxKey</a> ()</td></tr>
<tr class="memdesc:a16f629f10c23872f240c145d915a267d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function that begins the recursive get max key, returns key with largest value.  <a href="classDataStructure_1_1BinarySearchTree.html#a16f629f10c23872f240c145d915a267d">More...</a><br /></td></tr>
<tr class="separator:a16f629f10c23872f240c145d915a267d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a35d7654273b21329e06097b5884afe61"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1BinarySearchTree.html#a35d7654273b21329e06097b5884afe61">GetHeight</a> ()</td></tr>
<tr class="memdesc:a35d7654273b21329e06097b5884afe61"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function that beginst he recursive get height, returns the height of the tree.  <a href="classDataStructure_1_1BinarySearchTree.html#a35d7654273b21329e06097b5884afe61">More...</a><br /></td></tr>
<tr class="separator:a35d7654273b21329e06097b5884afe61"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a64651d83a65c70c091e497858f557ef1"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1BinarySearchTree.html#a64651d83a65c70c091e497858f557ef1">GetCount</a> ()</td></tr>
<tr class="memdesc:a64651d83a65c70c091e497858f557ef1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get amount of nodes in tree.  <a href="classDataStructure_1_1BinarySearchTree.html#a64651d83a65c70c091e497858f557ef1">More...</a><br /></td></tr>
<tr class="separator:a64651d83a65c70c091e497858f557ef1"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-methods"></a>
Private Member Functions</h2></td></tr>
<tr class="memitem:ac190bb7d2872d4d2b844210bcd1cf589"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode</a>&lt; TK, TD &gt; *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1BinarySearchTree.html#ac190bb7d2872d4d2b844210bcd1cf589">FindNode</a> (const TK &amp;key)</td></tr>
<tr class="memdesc:ac190bb7d2872d4d2b844210bcd1cf589"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function that begins the recursive find node process based on node's key.  <a href="classDataStructure_1_1BinarySearchTree.html#ac190bb7d2872d4d2b844210bcd1cf589">More...</a><br /></td></tr>
<tr class="separator:ac190bb7d2872d4d2b844210bcd1cf589"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a52a75668c7c7fe86cb2523a122c4fa1f"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1BinarySearchTree.html#a52a75668c7c7fe86cb2523a122c4fa1f">RecursiveGetInOrder</a> (<a class="el" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode</a>&lt; TK, TD &gt; *ptrCurrent, std::stringstream &amp;stream)</td></tr>
<tr class="memdesc:a52a75668c7c7fe86cb2523a122c4fa1f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Recursive in-order traversal function.  <a href="classDataStructure_1_1BinarySearchTree.html#a52a75668c7c7fe86cb2523a122c4fa1f">More...</a><br /></td></tr>
<tr class="separator:a52a75668c7c7fe86cb2523a122c4fa1f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a545f1a837f79216bb66d9cfd9abd5724"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1BinarySearchTree.html#a545f1a837f79216bb66d9cfd9abd5724">RecursiveGetPreOrder</a> (<a class="el" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode</a>&lt; TK, TD &gt; *ptrCurrent, std::stringstream &amp;stream)</td></tr>
<tr class="memdesc:a545f1a837f79216bb66d9cfd9abd5724"><td class="mdescLeft">&#160;</td><td class="mdescRight">Recursive pre-order traversal function.  <a href="classDataStructure_1_1BinarySearchTree.html#a545f1a837f79216bb66d9cfd9abd5724">More...</a><br /></td></tr>
<tr class="separator:a545f1a837f79216bb66d9cfd9abd5724"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af7ae1bff41e040651d457bff38e00f87"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1BinarySearchTree.html#af7ae1bff41e040651d457bff38e00f87">RecursiveGetPostOrder</a> (<a class="el" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode</a>&lt; TK, TD &gt; *ptrCurrent, std::stringstream &amp;stream)</td></tr>
<tr class="memdesc:af7ae1bff41e040651d457bff38e00f87"><td class="mdescLeft">&#160;</td><td class="mdescRight">Recursive post-order traversal function.  <a href="classDataStructure_1_1BinarySearchTree.html#af7ae1bff41e040651d457bff38e00f87">More...</a><br /></td></tr>
<tr class="separator:af7ae1bff41e040651d457bff38e00f87"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2cefdf57e6cd5eee93fe83240a06224e"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode</a>&lt; TK, TD &gt; *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1BinarySearchTree.html#a2cefdf57e6cd5eee93fe83240a06224e">RecursiveFindNode</a> (const TK &amp;key, <a class="el" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode</a>&lt; TK, TD &gt; *ptrCurrent)</td></tr>
<tr class="memdesc:a2cefdf57e6cd5eee93fe83240a06224e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Recurses through nodes in tree looking for node with given key.  <a href="classDataStructure_1_1BinarySearchTree.html#a2cefdf57e6cd5eee93fe83240a06224e">More...</a><br /></td></tr>
<tr class="separator:a2cefdf57e6cd5eee93fe83240a06224e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9068bcfbbff5dc93241a5faf980f6a78"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode</a>&lt; TK, TD &gt; *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1BinarySearchTree.html#a9068bcfbbff5dc93241a5faf980f6a78">RecursiveGetMax</a> (<a class="el" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode</a>&lt; TK, TD &gt; *ptrCurrent)</td></tr>
<tr class="memdesc:a9068bcfbbff5dc93241a5faf980f6a78"><td class="mdescLeft">&#160;</td><td class="mdescRight">Recurses through tree looking for the node with the maximum key value.  <a href="classDataStructure_1_1BinarySearchTree.html#a9068bcfbbff5dc93241a5faf980f6a78">More...</a><br /></td></tr>
<tr class="separator:a9068bcfbbff5dc93241a5faf980f6a78"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9e3500de82a7bf93d64f92fc636277b1"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode</a>&lt; TK, TD &gt; *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1BinarySearchTree.html#a9e3500de82a7bf93d64f92fc636277b1">RecursiveGetMin</a> (<a class="el" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode</a>&lt; TK, TD &gt; *ptrCurrent)</td></tr>
<tr class="memdesc:a9e3500de82a7bf93d64f92fc636277b1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Recurses through tree looking for the node with the minimum key value.  <a href="classDataStructure_1_1BinarySearchTree.html#a9e3500de82a7bf93d64f92fc636277b1">More...</a><br /></td></tr>
<tr class="separator:a9e3500de82a7bf93d64f92fc636277b1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4cf22a623f3265f82ec025058caa80a5"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1BinarySearchTree.html#a4cf22a623f3265f82ec025058caa80a5">RecursiveGetHeight</a> (<a class="el" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode</a>&lt; TK, TD &gt; *ptrCurrent)</td></tr>
<tr class="memdesc:a4cf22a623f3265f82ec025058caa80a5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Recurses through the tree comparing heights of left and right sub-trees to get the overall height.  <a href="classDataStructure_1_1BinarySearchTree.html#a4cf22a623f3265f82ec025058caa80a5">More...</a><br /></td></tr>
<tr class="separator:a4cf22a623f3265f82ec025058caa80a5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6a049f530dd6ac0211ef33c0a3b79cd5"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1BinarySearchTree.html#a6a049f530dd6ac0211ef33c0a3b79cd5">RecursiveContains</a> (const TK &amp;key, <a class="el" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode</a>&lt; TK, TD &gt; *ptrCurrent)</td></tr>
<tr class="memdesc:a6a049f530dd6ac0211ef33c0a3b79cd5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Recurses through the tree searching for a node with a matching key.  <a href="classDataStructure_1_1BinarySearchTree.html#a6a049f530dd6ac0211ef33c0a3b79cd5">More...</a><br /></td></tr>
<tr class="separator:a6a049f530dd6ac0211ef33c0a3b79cd5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9a70833be0a466064fa47b00a1d618af"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1BinarySearchTree.html#a9a70833be0a466064fa47b00a1d618af">RecursivePush</a> (const TK &amp;newKey, const TD &amp;newData, <a class="el" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode</a>&lt; TK, TD &gt; *ptrCurrent)</td></tr>
<tr class="memdesc:a9a70833be0a466064fa47b00a1d618af"><td class="mdescLeft">&#160;</td><td class="mdescRight">Recurses through the tree searching for a position to insert the new data based on its key.  <a href="classDataStructure_1_1BinarySearchTree.html#a9a70833be0a466064fa47b00a1d618af">More...</a><br /></td></tr>
<tr class="separator:a9a70833be0a466064fa47b00a1d618af"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acdff041da5aa4e72e7c77e8d735c1bbf"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1BinarySearchTree.html#acdff041da5aa4e72e7c77e8d735c1bbf">PopNode</a> (<a class="el" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode</a>&lt; TK, TD &gt; *ptrCurrent)</td></tr>
<tr class="memdesc:acdff041da5aa4e72e7c77e8d735c1bbf"><td class="mdescLeft">&#160;</td><td class="mdescRight">Removes a node - the root of its own subtree.  <a href="classDataStructure_1_1BinarySearchTree.html#acdff041da5aa4e72e7c77e8d735c1bbf">More...</a><br /></td></tr>
<tr class="separator:acdff041da5aa4e72e7c77e8d735c1bbf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aaf387bdd98abf4d87263a2c4b5eab54f"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode</a>&lt; TK, TD &gt; *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1BinarySearchTree.html#aaf387bdd98abf4d87263a2c4b5eab54f">GetSuccessor</a> (<a class="el" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode</a>&lt; TK, TD &gt; *ptrCurrent)</td></tr>
<tr class="memdesc:aaf387bdd98abf4d87263a2c4b5eab54f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets the node with the smallest key that is greater than ptrCurrent's key.  <a href="classDataStructure_1_1BinarySearchTree.html#aaf387bdd98abf4d87263a2c4b5eab54f">More...</a><br /></td></tr>
<tr class="separator:aaf387bdd98abf4d87263a2c4b5eab54f"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:a3c6a9c70728ff0309cbcc02d47c06433"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode</a>&lt; TK, TD &gt; *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1BinarySearchTree.html#a3c6a9c70728ff0309cbcc02d47c06433">m_ptrRoot</a></td></tr>
<tr class="memdesc:a3c6a9c70728ff0309cbcc02d47c06433"><td class="mdescLeft">&#160;</td><td class="mdescRight">A pointer to the root node of the tree; TK = data type of the key, TD = data type of the data.  <a href="classDataStructure_1_1BinarySearchTree.html#a3c6a9c70728ff0309cbcc02d47c06433">More...</a><br /></td></tr>
<tr class="separator:a3c6a9c70728ff0309cbcc02d47c06433"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a483543c8214d622bb7b820ba23b40df6"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1BinarySearchTree.html#a483543c8214d622bb7b820ba23b40df6">m_nodeCount</a></td></tr>
<tr class="memdesc:a483543c8214d622bb7b820ba23b40df6"><td class="mdescLeft">&#160;</td><td class="mdescRight">The amount of nodes in the tree.  <a href="classDataStructure_1_1BinarySearchTree.html#a483543c8214d622bb7b820ba23b40df6">More...</a><br /></td></tr>
<tr class="separator:a483543c8214d622bb7b820ba23b40df6"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="friends"></a>
Friends</h2></td></tr>
<tr class="memitem:a4f901b67b9d1a83f0c3be784eead987e"><td class="memItemLeft" align="right" valign="top">class&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1BinarySearchTree.html#a4f901b67b9d1a83f0c3be784eead987e">BinarySearchTreeTester</a></td></tr>
<tr class="memdesc:a4f901b67b9d1a83f0c3be784eead987e"><td class="mdescLeft">&#160;</td><td class="mdescRight">The tester is our friend.  <a href="classDataStructure_1_1BinarySearchTree.html#a4f901b67b9d1a83f0c3be784eead987e">More...</a><br /></td></tr>
<tr class="separator:a4f901b67b9d1a83f0c3be784eead987e"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><h3>template&lt;typename TK, typename TD&gt;<br />
class DataStructure::BinarySearchTree&lt; TK, TD &gt;</h3>

<p>A template binary search tree class that takes a KEY and a DATA. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="ab5814e0a82125eafc6f40fd84f793eb4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab5814e0a82125eafc6f40fd84f793eb4">&#9670;&nbsp;</a></span>BinarySearchTree()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename TK , typename TD &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classDataStructure_1_1BinarySearchTree.html">DataStructure::BinarySearchTree</a>&lt; TK, TD &gt;::<a class="el" href="classDataStructure_1_1BinarySearchTree.html">BinarySearchTree</a></td>
        </tr>
      </table>
</div><div class="memdoc">

<p><a class="el" href="classDataStructure_1_1BinarySearchTree.html" title="A template binary search tree class that takes a KEY and a DATA.">BinarySearchTree</a> Constructor. </p>
<p>Initialize the root node pointer to nullptr and the node count to 0. </p>

</div>
</div>
<a id="a2470cabc162d697002447db1cb85dc8b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2470cabc162d697002447db1cb85dc8b">&#9670;&nbsp;</a></span>~BinarySearchTree()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename TK , typename TD &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classDataStructure_1_1BinarySearchTree.html">DataStructure::BinarySearchTree</a>&lt; TK, TD &gt;::~<a class="el" href="classDataStructure_1_1BinarySearchTree.html">BinarySearchTree</a></td>
        </tr>
      </table>
</div><div class="memdoc">

<p><a class="el" href="classDataStructure_1_1BinarySearchTree.html" title="A template binary search tree class that takes a KEY and a DATA.">BinarySearchTree</a> Destructor. </p>
<p>If the root node pointer is not nullptr, then delete it. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="adab16db3a643345ac73548d01f5a5fdf"></a>
<h2 class="memtitle"><span class="permalink"><a href="#adab16db3a643345ac73548d01f5a5fdf">&#9670;&nbsp;</a></span>Contains()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename TK , typename TD &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classDataStructure_1_1BinarySearchTree.html">DataStructure::BinarySearchTree</a>&lt; TK, TD &gt;::Contains </td>
          <td>(</td>
          <td class="paramtype">const TK &amp;&#160;</td>
          <td class="paramname"><em>key</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Function that begins the recursive contains function. Check if key is contained within the tree. </p>
<p>Return the result of the RecursiveContains function, passing in the key and the root node pointer.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">key</td><td>The key to search for in the tree. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>True if the key is in the tree, or false otherwise. </dd></dl>

</div>
</div>
<a id="ac190bb7d2872d4d2b844210bcd1cf589"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac190bb7d2872d4d2b844210bcd1cf589">&#9670;&nbsp;</a></span>FindNode()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename TK , typename TD &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode</a>&lt; TK, TD &gt; * <a class="el" href="classDataStructure_1_1BinarySearchTree.html">DataStructure::BinarySearchTree</a>&lt; TK, TD &gt;::FindNode </td>
          <td>(</td>
          <td class="paramtype">const TK &amp;&#160;</td>
          <td class="paramname"><em>key</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Function that begins the recursive find node process based on node's key. </p>
<p>Begin the recursive search for a node with a key by calling the RecursiveFindNode, passing in the key and root node pointer.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">key</td><td>The key to search for in the tree. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The node found with the key given (possibly nullptr). </dd></dl>

</div>
</div>
<a id="a64651d83a65c70c091e497858f557ef1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a64651d83a65c70c091e497858f557ef1">&#9670;&nbsp;</a></span>GetCount()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename TK , typename TD &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classDataStructure_1_1BinarySearchTree.html">DataStructure::BinarySearchTree</a>&lt; TK, TD &gt;::GetCount</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Get amount of nodes in tree. </p>
<p>Return the count of nodes.</p>
<dl class="section return"><dt>Returns</dt><dd>The amonut of nodes in the tree. </dd></dl>

</div>
</div>
<a id="a616fe60e0b95d4a4910c9daf22f8f091"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a616fe60e0b95d4a4910c9daf22f8f091">&#9670;&nbsp;</a></span>GetData()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename TK , typename TD &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">TD &amp; <a class="el" href="classDataStructure_1_1BinarySearchTree.html">DataStructure::BinarySearchTree</a>&lt; TK, TD &gt;::GetData </td>
          <td>(</td>
          <td class="paramtype">const TK &amp;&#160;</td>
          <td class="paramname"><em>key</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Function that begins the recursive find node function. Get data relayed to some key stored in the tree. </p>
<p>Use the FindNode function to find the node that has the key given. If FindNode returns nullptr, then throw a std::runtime_error exception. Otherwise, return the node's data.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">key</td><td>The key to search for in the tree. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A reference to the data of the node. </dd></dl>

</div>
</div>
<a id="a35d7654273b21329e06097b5884afe61"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a35d7654273b21329e06097b5884afe61">&#9670;&nbsp;</a></span>GetHeight()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename TK , typename TD &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classDataStructure_1_1BinarySearchTree.html">DataStructure::BinarySearchTree</a>&lt; TK, TD &gt;::GetHeight</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Function that beginst he recursive get height, returns the height of the tree. </p>
<p>If the root node pointer is set to nullptr, return 0. Otherwise, begin the recursive get height process by calling RecursiveGetHeight and passing in the root node pointer.</p>
<dl class="section return"><dt>Returns</dt><dd>The height of the tree. </dd></dl>

</div>
</div>
<a id="a413cb728337d1aacb29fac517dc78962"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a413cb728337d1aacb29fac517dc78962">&#9670;&nbsp;</a></span>GetInOrder()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename TK , typename TD &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">std::string <a class="el" href="classDataStructure_1_1BinarySearchTree.html">DataStructure::BinarySearchTree</a>&lt; TK, TD &gt;::GetInOrder</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Function that begins the recursive in-order traversal. </p>
<p>Begin the recursive in-order traversal by calling RecursiveGetInOrder and passing in the root node pointer and the std::string stream.</p>
<dl class="section return"><dt>Returns</dt><dd>The list of keys in the tree, in-order. </dd></dl>

</div>
</div>
<a id="a16f629f10c23872f240c145d915a267d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a16f629f10c23872f240c145d915a267d">&#9670;&nbsp;</a></span>GetMaxKey()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename TK , typename TD &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">TK &amp; <a class="el" href="classDataStructure_1_1BinarySearchTree.html">DataStructure::BinarySearchTree</a>&lt; TK, TD &gt;::GetMaxKey</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Function that begins the recursive get max key, returns key with largest value. </p>
<p>Begin the recursive search for the max key by calling the RecursiveGetMax function, passing in the root node pointer.</p>
<dl class="section return"><dt>Returns</dt><dd>A reference to the max key in the tree. </dd></dl>

</div>
</div>
<a id="afaa0ece8c510e5c850b85a6b72f1940d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afaa0ece8c510e5c850b85a6b72f1940d">&#9670;&nbsp;</a></span>GetMinKey()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename TK , typename TD &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">TK &amp; <a class="el" href="classDataStructure_1_1BinarySearchTree.html">DataStructure::BinarySearchTree</a>&lt; TK, TD &gt;::GetMinKey</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Function that begins the recursive get min key, returns key with smallest value. </p>
<p>Begin the recursive search for the min key by calling the RecursiveGetMin function, passing in the root node pointer.</p>
<dl class="section return"><dt>Returns</dt><dd>A reference to the min key in the tree. </dd></dl>

</div>
</div>
<a id="aad0331b880a93a1f5da7eafa54422c23"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aad0331b880a93a1f5da7eafa54422c23">&#9670;&nbsp;</a></span>GetPostOrder()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename TK , typename TD &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">std::string <a class="el" href="classDataStructure_1_1BinarySearchTree.html">DataStructure::BinarySearchTree</a>&lt; TK, TD &gt;::GetPostOrder</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Function that begins the recursive post-order traversal. </p>
<p>Begin the recursive post-order traversal by calling RecursiveGetPostOrder and passing in the root node pointer and the std::string stream.</p>
<dl class="section return"><dt>Returns</dt><dd>The list of keys in the tree, post-order. </dd></dl>

</div>
</div>
<a id="a6331270db8ac855cb6d71bf64c3a2376"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6331270db8ac855cb6d71bf64c3a2376">&#9670;&nbsp;</a></span>GetPreOrder()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename TK , typename TD &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">std::string <a class="el" href="classDataStructure_1_1BinarySearchTree.html">DataStructure::BinarySearchTree</a>&lt; TK, TD &gt;::GetPreOrder</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Function that begins the recursive pre-order traversal. </p>
<p>Begin the recursive pre-order traversal by calling RecursiveGetPreOrder and passing in the root node pointer and the std::string stream.</p>
<dl class="section return"><dt>Returns</dt><dd>The list of keys in the tree, pre-order. </dd></dl>

</div>
</div>
<a id="aa76af5cc4dffce8274d99c53b01259ca"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa76af5cc4dffce8274d99c53b01259ca">&#9670;&nbsp;</a></span>GetRoot()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename TK , typename TD &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">TD &amp; <a class="el" href="classDataStructure_1_1BinarySearchTree.html">DataStructure::BinarySearchTree</a>&lt; TK, TD &gt;::GetRoot</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Retrieves the item at the root. </p>
<p>Returns the data located at the root of the tree, or throws an exception if the tree is empty.</p>
<dl class="section return"><dt>Returns</dt><dd>The data stored at the root of the tree </dd></dl>

</div>
</div>
<a id="aaf387bdd98abf4d87263a2c4b5eab54f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aaf387bdd98abf4d87263a2c4b5eab54f">&#9670;&nbsp;</a></span>GetSuccessor()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename TK , typename TD &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode</a>&lt; TK, TD &gt; * <a class="el" href="classDataStructure_1_1BinarySearchTree.html">DataStructure::BinarySearchTree</a>&lt; TK, TD &gt;::GetSuccessor </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode</a>&lt; TK, TD &gt; *&#160;</td>
          <td class="paramname"><em>ptrCurrent</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Gets the node with the smallest key that is greater than ptrCurrent's key. </p>

</div>
</div>
<a id="acdff041da5aa4e72e7c77e8d735c1bbf"></a>
<h2 class="memtitle"><span class="permalink"><a href="#acdff041da5aa4e72e7c77e8d735c1bbf">&#9670;&nbsp;</a></span>PopNode()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename TK , typename TD &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classDataStructure_1_1BinarySearchTree.html">DataStructure::BinarySearchTree</a>&lt; TK, TD &gt;::PopNode </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode</a>&lt; TK, TD &gt; *&#160;</td>
          <td class="paramname"><em>ptrCurrent</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Removes a node - the root of its own subtree. </p>

</div>
</div>
<a id="afa25866546d8f5b0abeebf3fabe5f0ba"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afa25866546d8f5b0abeebf3fabe5f0ba">&#9670;&nbsp;</a></span>PopRoot()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename TK , typename TD &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classDataStructure_1_1BinarySearchTree.html">DataStructure::BinarySearchTree</a>&lt; TK, TD &gt;::PopRoot</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Removes the root item and reorganizes the tree. </p>

</div>
</div>
<a id="a1539ce01efd9c9a6c1b83c2b0ca6b6f3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1539ce01efd9c9a6c1b83c2b0ca6b6f3">&#9670;&nbsp;</a></span>Push()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename TK , typename TD &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classDataStructure_1_1BinarySearchTree.html">DataStructure::BinarySearchTree</a>&lt; TK, TD &gt;::Push </td>
          <td>(</td>
          <td class="paramtype">const TK &amp;&#160;</td>
          <td class="paramname"><em>newKey</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const TD &amp;&#160;</td>
          <td class="paramname"><em>newData</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Function that begins the recursive push function. Add new item to tree. </p>
<p>Error check: If the key is already in the tree, then throw a std::runtime_error with an error message. (Use teh Contains method)</p>
<p>Scenario 1: If m_ptrRoot is nullptr, create the new node here.</p>
<p>Scenario 2: Otherwise, start the push by calling the RecursivePush function, passing in the key, data, and the root node pointer.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">newKey</td><td>The key of the new item to be added. </td></tr>
    <tr><td class="paramname">newData</td><td>The data of the new item to be added. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a6a049f530dd6ac0211ef33c0a3b79cd5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6a049f530dd6ac0211ef33c0a3b79cd5">&#9670;&nbsp;</a></span>RecursiveContains()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename TK , typename TD &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classDataStructure_1_1BinarySearchTree.html">DataStructure::BinarySearchTree</a>&lt; TK, TD &gt;::RecursiveContains </td>
          <td>(</td>
          <td class="paramtype">const TK &amp;&#160;</td>
          <td class="paramname"><em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode</a>&lt; TK, TD &gt; *&#160;</td>
          <td class="paramname"><em>ptrCurrent</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Recurses through the tree searching for a node with a matching key. </p>
<p>Recurses through the tree, looking to see if a node with the key given exists.</p>
<h4><a class="anchor" id="autotoc_md10"></a>
TERMINATING CASES:</h4>
<ol type="1">
<li>False if ptrCurrent is nullptr.</li>
<li>True if ptrCurrent's key matches the key.</li>
<li>False if there are no more child nodes to traverse (no left child / right child of ptrCurrent).</li>
</ol>
<h4><a class="anchor" id="autotoc_md11"></a>
RECURSIVE CASES:</h4>
<ol type="1">
<li>Recurse left if the key is less than ptrCurrent-&gt;key, returning that value.</li>
<li>Recurse right if the key is greater than ptrCurrent-&gt;key, returning that value.</li>
</ol>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">key</td><td>The key we're searching for. </td></tr>
    <tr><td class="paramname">ptrCurrent</td><td>The current node we're investigating. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>True if the key is found, or false otherwise. </dd></dl>

</div>
</div>
<a id="a2cefdf57e6cd5eee93fe83240a06224e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2cefdf57e6cd5eee93fe83240a06224e">&#9670;&nbsp;</a></span>RecursiveFindNode()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename TK , typename TD &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode</a>&lt; TK, TD &gt; * <a class="el" href="classDataStructure_1_1BinarySearchTree.html">DataStructure::BinarySearchTree</a>&lt; TK, TD &gt;::RecursiveFindNode </td>
          <td>(</td>
          <td class="paramtype">const TK &amp;&#160;</td>
          <td class="paramname"><em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode</a>&lt; TK, TD &gt; *&#160;</td>
          <td class="paramname"><em>ptrCurrent</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Recurses through nodes in tree looking for node with given key. </p>
<p>Recurses through the tree, looking to see if a node with the key given exists.</p>
<h4><a class="anchor" id="autotoc_md12"></a>
TERMINATING CASES:</h4>
<ol type="1">
<li>nullptr if ptrCurrent is nullptr.</li>
<li>ptrCurrent if ptrCurrent's key matches the key.</li>
</ol>
<h4><a class="anchor" id="autotoc_md13"></a>
RECURSIVE CASES:</h4>
<ol type="1">
<li>Recurse left if the key is less than ptrCurrent-&gt;key, returning that value.</li>
<li>Recurse right if the key is greater than ptrCurrent-&gt;key, returning that value.</li>
</ol>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">key</td><td>The key we're searching for. </td></tr>
    <tr><td class="paramname">ptrCurrent</td><td>The current node we're investigating. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The node with the matching key if found, nullptr otherwise. </dd></dl>

</div>
</div>
<a id="a4cf22a623f3265f82ec025058caa80a5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4cf22a623f3265f82ec025058caa80a5">&#9670;&nbsp;</a></span>RecursiveGetHeight()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename TK , typename TD &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classDataStructure_1_1BinarySearchTree.html">DataStructure::BinarySearchTree</a>&lt; TK, TD &gt;::RecursiveGetHeight </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode</a>&lt; TK, TD &gt; *&#160;</td>
          <td class="paramname"><em>ptrCurrent</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Recurses through the tree comparing heights of left and right sub-trees to get the overall height. </p>
<p>Recurse to get the max height of the left and right subtree in order to find this tree's height.</p>
<ol type="1">
<li>If ptrCurrent is nullptr, return 0.</li>
<li>Create two int variables to store the leftHeight and the rightHeight. Initialize both to 0.</li>
<li>If ptrCurrent has a left child, recurse left and store the result into leftHeight, + 1 to count the current node.</li>
<li>If ptrCurrent has a right child, recurse right and store the result into rightHeight, +1 to count the current node.</li>
<li>If leftHeight is greater than rightHeight, return leftHeight.</li>
<li>Otherwise, return rightHeight. </li>
</ol>

</div>
</div>
<a id="a52a75668c7c7fe86cb2523a122c4fa1f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a52a75668c7c7fe86cb2523a122c4fa1f">&#9670;&nbsp;</a></span>RecursiveGetInOrder()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename TK , typename TD &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classDataStructure_1_1BinarySearchTree.html">DataStructure::BinarySearchTree</a>&lt; TK, TD &gt;::RecursiveGetInOrder </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode</a>&lt; TK, TD &gt; *&#160;</td>
          <td class="paramname"><em>ptrCurrent</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::stringstream &amp;&#160;</td>
          <td class="paramname"><em>stream</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Recursive in-order traversal function. </p>
<p>Recurse in-order, building the stream.</p>
<p>IF ptrCrrrent IS nullptr THEN JUST RETURN.</p>
<ol type="1">
<li>Recurse to the left child.</li>
<li>Stream out the current node's key (<code>stream &lt;&lt; ptrCurrent-&gt;key;</code>)</li>
<li>Recurse to the right child. </li>
</ol>

</div>
</div>
<a id="a9068bcfbbff5dc93241a5faf980f6a78"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9068bcfbbff5dc93241a5faf980f6a78">&#9670;&nbsp;</a></span>RecursiveGetMax()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename TK , typename TD &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode</a>&lt; TK, TD &gt; * <a class="el" href="classDataStructure_1_1BinarySearchTree.html">DataStructure::BinarySearchTree</a>&lt; TK, TD &gt;::RecursiveGetMax </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode</a>&lt; TK, TD &gt; *&#160;</td>
          <td class="paramname"><em>ptrCurrent</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Recurses through tree looking for the node with the maximum key value. </p>
<p>Recurse to find the node with the max key in the tree.</p>
<h4><a class="anchor" id="autotoc_md14"></a>
TERMINATING CASE:</h4>
<ol type="1">
<li>If ptrCurrent is nullptr, throw a std::runtime_error.</li>
<li>Otherwise, if ptrCurrent does not have a right child, we are at the max node: return ptrCurrent.</li>
</ol>
<h4><a class="anchor" id="autotoc_md15"></a>
RECURSIVE CASE:</h4>
<ol type="1">
<li>Recurse to the right, returning the result. </li>
</ol>

</div>
</div>
<a id="a9e3500de82a7bf93d64f92fc636277b1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9e3500de82a7bf93d64f92fc636277b1">&#9670;&nbsp;</a></span>RecursiveGetMin()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename TK , typename TD &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode</a>&lt; TK, TD &gt; * <a class="el" href="classDataStructure_1_1BinarySearchTree.html">DataStructure::BinarySearchTree</a>&lt; TK, TD &gt;::RecursiveGetMin </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode</a>&lt; TK, TD &gt; *&#160;</td>
          <td class="paramname"><em>ptrCurrent</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Recurses through tree looking for the node with the minimum key value. </p>
<p>Recurse to find the node with the min key in the tree.</p>
<h4><a class="anchor" id="autotoc_md16"></a>
TERMINATING CASES:</h4>
<ol type="1">
<li>If ptrCurrent is nullptr, throw a std::runtime_error.</li>
<li>Otherwise, if ptrCurrent does not have a left child, we are at the min node: return ptrCurrent.</li>
</ol>
<h4><a class="anchor" id="autotoc_md17"></a>
RECURSIVE CASE:</h4>
<ol type="1">
<li>Recurse to the left, returning the result. </li>
</ol>

</div>
</div>
<a id="af7ae1bff41e040651d457bff38e00f87"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af7ae1bff41e040651d457bff38e00f87">&#9670;&nbsp;</a></span>RecursiveGetPostOrder()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename TK , typename TD &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classDataStructure_1_1BinarySearchTree.html">DataStructure::BinarySearchTree</a>&lt; TK, TD &gt;::RecursiveGetPostOrder </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode</a>&lt; TK, TD &gt; *&#160;</td>
          <td class="paramname"><em>ptrCurrent</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::stringstream &amp;&#160;</td>
          <td class="paramname"><em>stream</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Recursive post-order traversal function. </p>
<p>Recurse post-order, building the stream.</p>
<p>IF ptrCrrrent IS nullptr THEN JUST RETURN.</p>
<ol type="1">
<li>Recurse to the left child.</li>
<li>Recurse to the right child.</li>
</ol>
<ol type="1">
<li>Stream out the current node's key (<code>stream &lt;&lt; ptrCurrent-&gt;key;</code>) </li>
</ol>

</div>
</div>
<a id="a545f1a837f79216bb66d9cfd9abd5724"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a545f1a837f79216bb66d9cfd9abd5724">&#9670;&nbsp;</a></span>RecursiveGetPreOrder()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename TK , typename TD &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classDataStructure_1_1BinarySearchTree.html">DataStructure::BinarySearchTree</a>&lt; TK, TD &gt;::RecursiveGetPreOrder </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode</a>&lt; TK, TD &gt; *&#160;</td>
          <td class="paramname"><em>ptrCurrent</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::stringstream &amp;&#160;</td>
          <td class="paramname"><em>stream</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Recursive pre-order traversal function. </p>
<p>Recurse pre-order, building the stream.</p>
<p>IF ptrCrrrent IS nullptr THEN JUST RETURN.</p>
<ol type="1">
<li>Stream out the current node's key (<code>stream &lt;&lt; ptrCurrent-&gt;key;</code>)s</li>
<li>Recurse to the left child.</li>
<li>Recurse to the right child. </li>
</ol>

</div>
</div>
<a id="a9a70833be0a466064fa47b00a1d618af"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9a70833be0a466064fa47b00a1d618af">&#9670;&nbsp;</a></span>RecursivePush()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename TK , typename TD &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classDataStructure_1_1BinarySearchTree.html">DataStructure::BinarySearchTree</a>&lt; TK, TD &gt;::RecursivePush </td>
          <td>(</td>
          <td class="paramtype">const TK &amp;&#160;</td>
          <td class="paramname"><em>newKey</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const TD &amp;&#160;</td>
          <td class="paramname"><em>newData</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode</a>&lt; TK, TD &gt; *&#160;</td>
          <td class="paramname"><em>ptrCurrent</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Recurses through the tree searching for a position to insert the new data based on its key. </p>
<p>Recurses through the tree, finding the proper place to put a new node.</p>
<h4><a class="anchor" id="autotoc_md7"></a>
Creating a node at ptrCurrent:</h4>
<ul>
<li>Initialize the new node at the pointer. You can set its key and data via the Node constructor.<ul>
<li><code>ptrCurrent = new Node&lt;TK,TD&gt;( newKey, newData );</code> OR</li>
<li><code>ptrCurrent-&gt;ptrLeft = new Node&lt;TK,TD&gt;( newKey, newData );</code> OR</li>
<li><code>ptrCurrent-&gt;ptrRight = new Node&lt;TK,TD&gt;( newKey, newData );</code></li>
</ul>
</li>
<li>Increment the node count by 1.<ul>
<li><code>m_nodeCount++;</code></li>
</ul>
</li>
</ul>
<h4><a class="anchor" id="autotoc_md8"></a>
TERMINATING CASES:</h4>
<ol type="1">
<li>If ptrCurrent is nullptr, throw a runtime error stating that the node is nullptr.</li>
<li>Otherwise if the newKey is less than the ptrCurrent's key AND there is no node to the left, then create the node to the left.</li>
<li>Otherwise if the newKey is greater than the ptrCurrent's key AND there is no node to the right, then create the node to the right.</li>
</ol>
<h4><a class="anchor" id="autotoc_md9"></a>
RECURSIVE CASES:</h4>
<ol type="1">
<li>If the newKey is less than the ptrCurrent's key AND there IS a node to the left, recurse left.</li>
<li>Otherwise if the newKey is greater than the ptrCurrent's key AND there IS a node to the right, recurse right. </li>
</ol>

</div>
</div>
<a id="a459c979a497014e725f20e0584eefe97"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a459c979a497014e725f20e0584eefe97">&#9670;&nbsp;</a></span>ShiftNodes()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename TK , typename TD &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classDataStructure_1_1BinarySearchTree.html">DataStructure::BinarySearchTree</a>&lt; TK, TD &gt;::ShiftNodes </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode</a>&lt; TK, TD &gt; *&#160;</td>
          <td class="paramname"><em>node1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode</a>&lt; TK, TD &gt; *&#160;</td>
          <td class="paramname"><em>node2</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Shifts nodes for deletion operation. </p>

</div>
</div>
<h2 class="groupheader">Friends And Related Function Documentation</h2>
<a id="a4f901b67b9d1a83f0c3be784eead987e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4f901b67b9d1a83f0c3be784eead987e">&#9670;&nbsp;</a></span>BinarySearchTreeTester</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename TK , typename TD &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">friend class <a class="el" href="classDataStructure_1_1BinarySearchTreeTester.html">BinarySearchTreeTester</a></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">friend</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>The tester is our friend. </p>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a id="a483543c8214d622bb7b820ba23b40df6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a483543c8214d622bb7b820ba23b40df6">&#9670;&nbsp;</a></span>m_nodeCount</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename TK , typename TD &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classDataStructure_1_1BinarySearchTree.html">DataStructure::BinarySearchTree</a>&lt; TK, TD &gt;::m_nodeCount</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>The amount of nodes in the tree. </p>

</div>
</div>
<a id="a3c6a9c70728ff0309cbcc02d47c06433"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3c6a9c70728ff0309cbcc02d47c06433">&#9670;&nbsp;</a></span>m_ptrRoot</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename TK , typename TD &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode</a>&lt;TK, TD&gt;* <a class="el" href="classDataStructure_1_1BinarySearchTree.html">DataStructure::BinarySearchTree</a>&lt; TK, TD &gt;::m_ptrRoot</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>A pointer to the root node of the tree; TK = data type of the key, TD = data type of the data. </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>DataStructure/BinarySearchTree/<a class="el" href="BinarySearchTree_8h_source.html">BinarySearchTree.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
